/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "ADMM.h"

using namespace ADMMLib;

ADMM::ADMM(void)
	: mAlpha(0.1)
	, mUDec(1)
{
}

ADMM::~ADMM(void)
{
}

void ADMM::InitXNodes()
{
	for (int i=0; i<(int)mpXNodes.size(); i++)
		mpXNodes[i]->Init();
}

void ADMM::InitXNodeVals()
{
	for (int i=0; i<(int)mpXNodes.size(); i++)
		mpXNodes[i]->InitVal();
}

void ADMM::RunOneStep()
{
#pragma omp parallel for
	for (int i=0; i<(int)mpXNodes.size(); i++)
	{
		mpXNodes[i]->FetchN();
	}

#pragma omp parallel for
	for (int i=0; i<(int)mpZNodes.size(); i++)
		mpZNodes[i]->ResetIntermediate();

//#pragma omp parallel for
	for (int i=0; i<(int)mpXNodes.size(); i++)
	{
		mpXNodes[i]->SolveX();
		
	}

	for (int i=0; i<(int)mpXNodes.size(); i++)
		mpXNodes[i]->SetZInput();

#pragma omp parallel for
	for (int i=0; i<(int)mpZNodes.size(); i++)
	{
		mpZNodes[i]->UpdateZ();
	}

#pragma omp parallel for
	for (int i=0; i<(int)mpXNodes.size(); i++)
	{
		mpXNodes[i]->UpdateU();
	}

}
