/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include "..\StaticFEM\Config.h"
#include <vector>

namespace ADMMLib
{

class ZNode;
class ADMM;

class XNode // per function node
{
public:
	XNode(int iSize = 0);
	~XNode(void);

	virtual void Init(){}
	virtual void InitVal()
	{
		m_n.assign(m_n.size(), 0);
		m_x.assign(m_n.size(), 0);
		m_u.assign(m_n.size(), 0);
		m_rhoIn.assign(m_n.size(), 0);
		m_rhoOut.assign(m_n.size(), 0);
	}

	std::vector<_T_FLOAT> m_n;
	std::vector<_T_FLOAT> m_x;
	std::vector<_T_FLOAT> m_u;
	std::vector<_T_FLOAT> m_rhoIn;
	std::vector<_T_FLOAT> m_rhoOut;
	std::vector<ZNode*> mp_z;

	virtual void SolveX() = 0;
	void FetchN();
	void SetZInput();
	void UpdateU();

	ADMM* mpADMM;

};

}