#pragma once

#include <vector>
#include "Mesh.h"
#include "..\..\SSSLib\SSSSmallVec.h"

namespace ExpMapExp
{
	struct Point
	{
		SSSLib::Vec3f mPst;
		SSSLib::Vec3f mNormal;
	};

	extern void LoadAndAppendSamples(const char* iFileName,
		float iDiskSize,
		SSSLib::Vec3f iCtr,
		float iRadius,
		std::vector<Point>& oPt);

	extern void FilterSamples(Mesh& iMesh,
		const std::vector<Point>& iSamples,
		std::vector<Point>& oSamples);

	extern void WriteSamples(const char* iFileName,
		const std::vector<Point>& iSamples);

	extern void WriteSamplesObj(const char* iFileName,
		const std::vector<Point>& iSamples);

	extern void WriteSamplesPly(const char* iFileName,
		const std::vector<Point>& iSamples);

	extern void ReadSamples(const char* iFileName,
		std::vector<Point>& oSamples);

}