/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include <boost/random/linear_congruential.hpp>
#include <boost/random/uniform_int.hpp>
#include <boost/random/uniform_real.hpp>
#include <boost/random/variate_generator.hpp>
#include <vector>

namespace SSSLib
{

class RandNum
{
public:
	boost::rand48* generator;
	boost::uniform_int<>* range;
	boost::variate_generator<boost::rand48&, boost::uniform_int<> >* roll;
	RandNum()
	{
		Init();
	}
	void Init()
	{
		generator = new boost::rand48;
		range = new boost::uniform_int<>(0, 2147483647);
		roll = new boost::variate_generator<boost::rand48&, boost::uniform_int<> >(*generator, *range);

	}
	RandNum(const RandNum& iR)
	{
		Init();
	}
	RandNum& operator=(const RandNum& iR)
	{
		delete range;
		delete generator;
		delete roll;
		Init();
		return *this;
	}
	~RandNum()
	{
		delete range;
		delete generator;
		delete roll;
	}
	int Rand()
	{
		return (*roll)();
	}
	static std::vector<RandNum> sGenerator;
	static void Reseed(int iN);
};
static int GetRand(int iN)
{
	return rand();
	//if (iN >= (int)RandNum::sGenerator.size())
	//	RandNum::Reseed(iN+1);
	//return RandNum::sGenerator[iN].Rand();
}

}

