/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "SCVMat.h"

void SCVMat<uchar>::CreateMat(int iRows, int iCols, int iNChan)
{
	pMat = cvCreateMat(iRows, iCols, CV_8UC(iNChan));
}

void SCVMat<short>::CreateMat(int iRows, int iCols, int iNChan)
{
	pMat = cvCreateMat(iRows, iCols, CV_16SC(iNChan));
}

void SCVMat<int>::CreateMat(int iRows, int iCols, int iNChan)
{
	pMat = cvCreateMat(iRows, iCols, CV_32SC(iNChan));
}

void SCVMat<float>::CreateMat(int iRows, int iCols, int iNChan)
{
	pMat = cvCreateMat(iRows, iCols, CV_32FC(iNChan));
}

void SCVMat<double>::CreateMat(int iRows, int iCols, int iNChan)
{
	pMat = cvCreateMat(iRows, iCols, CV_64FC(iNChan));
}

uchar* SCVMat<uchar>::GetDataPtr(){return pMat->data.ptr;}
short* SCVMat<short>::GetDataPtr(){return pMat->data.s;}
int* SCVMat<int>::GetDataPtr(){return pMat->data.i;}
float* SCVMat<float>::GetDataPtr(){return pMat->data.fl;}
double* SCVMat<double>::GetDataPtr(){return pMat->data.db;}

const uchar* SCVMat<uchar>::GetDataPtr() const{return pMat->data.ptr;}
const short* SCVMat<short>::GetDataPtr() const{return pMat->data.s;}
const int* SCVMat<int>::GetDataPtr() const{return pMat->data.i;}
const float* SCVMat<float>::GetDataPtr() const{return pMat->data.fl;}
const double* SCVMat<double>::GetDataPtr() const{return pMat->data.db;}