/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include "SSSFunc.h"
#include "SSSSmallVec.h"

namespace SSSLib
{
	template <class _TVec2>
	_TVec2 ComplexMul(const _TVec2& iV1, const _TVec2& iV2)
	{
		return _TVec2(iV1[0]*iV2[0]-iV1[1]*iV2[1], iV1[0]*iV2[1]+iV1[1]*iV2[0]);
	}

	template <class _TVec2>
	_TVec2 Conj(const _TVec2& iV1)
	{
		return _TVec2(iV1[0], -iV1[1]);
	}

	template <class _TVec2>
	_TVec2 ComplexDiv(const _TVec2& iV1, const _TVec2& iV2)
	{
		_TVec2 tmp = ComplexMul(iV1, _TVec2(iV2[0], -iV2[1]));
		_TVec2::t_Ele len = sqr(iV2[0]) + sqr(iV2[1]);
		return _TVec2(tmp[0]/len, tmp[1]/len);
	}
	template <typename _TVal>
	SSSLib::SmallVec<_TVal, 2> expi(_TVal val){return SSSLib::SmallVec<_TVal, 2>(cos(val), sin(val));}
}