/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "SSSLib.h"
#include <iostream>

using namespace SSSLib;
using namespace std;

SSSLib::FileEnum::FileEnum(const TCHAR *iDirName)
{
	SetPath(iDirName);	
}

void FileEnum::SetPath(const TCHAR *iDirName)
{
	mFilePathName = tstring(iDirName);
	mIsMoreFile = true;
	mFindFile=FindFirstFile(
		tstring(mFilePathName+__T("*")).c_str(),&mFindData);
	if (mFindFile==INVALID_HANDLE_VALUE)
	{
		cout<<"Directory Not Found";
		mIsMoreFile=false;
	}
}

bool SSSLib::FileEnum::EnumFileName(tstring& oStr)
{
	if (!mIsMoreFile)
		return false;
	oStr=tstring(mFilePathName+mFindData.cFileName);
	mIsMoreFile=FindNextFile(mFindFile,&mFindData);
	return true;
}

bool SSSLib::FileEnum::EnumFileNameNoPath(tstring& oStr)
{
	if (!mIsMoreFile)
		return false;
	oStr=tstring(mFindData.cFileName);
	mIsMoreFile=FindNextFile(mFindFile,&mFindData);
	return true;
}

