/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include <tchar.h>
#include <string>
#include <xstring>
#include <windows.h>
#include <vector>
#include <math.h>
#include <fstream>

namespace SSSLib {

	typedef std::basic_string<TCHAR,std::char_traits<TCHAR>,
		std::allocator<TCHAR> >	tstring;

	inline bool CheckFileExist(const char* iFileName)
	{std::ifstream file(iFileName); return file.is_open();}

	class FileEnum
	{
	public:
		FileEnum(const TCHAR* iDirName); // must be "xxx//"
		FileEnum(){}
		~FileEnum(){}
		void SetPath(const TCHAR *iDirName);
		bool EnumFileName(tstring& oStr);
		bool EnumFileNameNoPath(tstring& oStr);
	protected:
		WIN32_FIND_DATA mFindData;
		HANDLE mFindFile;
		tstring mFilePathName;
		BOOL mIsMoreFile;
	};

#ifdef _CV_H_
	template <typename typeT>
	CvScalar Data2Color(typeT iData, typeT iLowBound, typeT iHighBound)
	{
		iData = iData - iLowBound;
		iData = iData * 512 / (iHighBound - iLowBound);
		return cvScalar(
			Bound<typeT>(255-iData, 0, 255),
			Bound<typeT>(255-abs(iData-255), 0, 255),
			Bound<typeT>(iData-256, 0, 255) );
	}
#endif
}
