/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "OGLCam.h"
#include "OGLFrame.h"
#include <GL/freeglut.h>

using namespace SSSLib;

OGLCam::OGLCam(Vec3f iPosi, Vec3f iRot)
: Posi(iPosi)
, Rot(iRot)
, Fovy(45)
, ZNear(0.1)
, ZFar(100)
, mFlipYZ(false)
{
}

OGLCam::~OGLCam(void)
{
}

void OGLCam::SetProjMatrix(Vec4i iWindowTLBR)
{
	GLint retMatrixMode;
	glGetIntegerv(GL_MATRIX_MODE, &retMatrixMode);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	//glViewport(0, 0, glutGet(GLUT_WINDOW_WIDTH), glutGet(GLUT_WINDOW_HEIGHT));
	//Aspect = float(glutGet(GLUT_WINDOW_WIDTH)) / glutGet(GLUT_WINDOW_HEIGHT);
	glViewport(iWindowTLBR[1],
				iWindowTLBR[2],
				iWindowTLBR[3]-iWindowTLBR[1],
				iWindowTLBR[0]-iWindowTLBR[2]);
	Aspect = float(iWindowTLBR[3]-iWindowTLBR[1]) / (iWindowTLBR[0]-iWindowTLBR[2]);
	gluPerspective( Fovy, Aspect, ZNear, ZFar);
	glMatrixMode(retMatrixMode);
}

void OGLCam::SetViewMatrix()
{
	GLint retMatrixMode;
	glGetIntegerv(GL_MATRIX_MODE, &retMatrixMode);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	glRotatef(-Rot[0], 1.0f, 0.0f, 0.0f);
	glRotatef(-Rot[1], 0.0f, 1.0f, 0.0f);
	glRotatef(-Rot[2], 0.0f, 0.0f, 1.0f);

	glTranslatef( -Posi[0], -Posi[1], -Posi[2]);

	if (mFlipYZ)
		glRotatef(-90, 1.0f, 0.0f, 0.0f);

	glMatrixMode(retMatrixMode);
}