/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include "../SSSSmallVec.h"
#include <GL/freeglut.h>

#ifndef _M_PI
#define _M_PI 3.1415926535897932384626433832795
#endif

namespace SSSLib
{

class OGLCam
{
public:
	OGLCam(Vec3f iPosi = Vec3f(0,0,5.0f),
		Vec3f iRot = Vec3f(0,0,0)
		);
	~OGLCam(void);
	Vec3f Posi;
	Vec3f Rot;
	void SetProjMatrix(){SetProjMatrix(Vec4i(glutGet(GLUT_WINDOW_HEIGHT), 0, 0, glutGet(GLUT_WINDOW_WIDTH)));}
	void SetProjMatrix(Vec4i iWindowTLBR);
	void SetViewMatrix();
	GLdouble Fovy;
	GLdouble Aspect;
	GLdouble ZNear;
	GLdouble ZFar;
	bool mFlipYZ;
};
}