/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once
#include "OGLScene.h"

namespace SSSLib
{

class OGLCommonScene : public OGLScene
{
public:
	OGLCommonScene(void): OGLScene(), mKeyDown(256), mSpecialDown(256), mMLDown(0), mMMDown(0), mMRDown(0)
	{SetCommonFunction();}
	~OGLCommonScene(void){}
	static OGLCommonScene* GetCurScene(){return (OGLCommonScene*)spCurrentScene;}
	virtual void SetCommonFunction()
	{
		AddKeyboard(CommomKeyboardFunc);
		AddKeyboardUp(CommomKeyboardUpFunc);
		AddSpecial(CommonSpecialFunc);
		AddSpecialUp(CommonSpecialUpFunc);

//		AddKeyboard(KeyboardExitFunc);

		AddMouse(CommonMouseFunc);
		AddMotion(CommonMotionFunc);

		AddComputeBeforeDisplay(CommonComputeBeforeDisplay);
	}
	// some data
	std::vector<bool> mKeyDown; // keyboard
	std::vector<bool> mSpecialDown; // keyboard special key
	int mMouseX;
	int mMouseY;
	int mDeltaX;
	int mDeltaY;
	bool mMLDown;
	bool mMMDown;
	bool mMRDown;

	// some basic call back functions
	static inline void CommomKeyboardFunc(unsigned char key, int x, int y){((OGLCommonScene*)spCurrentScene)->mKeyDown[key] = true;}
	static inline void CommomKeyboardUpFunc(unsigned char key, int x, int y){((OGLCommonScene*)spCurrentScene)->mKeyDown[key] = false;}
	static inline void CommonSpecialFunc(int key, int x, int y){((OGLCommonScene*)spCurrentScene)->mSpecialDown[key] = true;}
	static inline void CommonSpecialUpFunc(int key, int x, int y){((OGLCommonScene*)spCurrentScene)->mSpecialDown[key] = false;}

	static inline void KeyboardExitFunc(unsigned char key, int x, int y){ if (key==27) exit(0);}

	static inline void CommonMouseFunc(int button, int state, int x, int y)
	{
		if (button == GLUT_LEFT_BUTTON)
			((OGLCommonScene*)spCurrentScene)->mMLDown = !state;
		if (button == GLUT_MIDDLE_BUTTON) ((OGLCommonScene*)spCurrentScene)->mMMDown = !state;
		if (button == GLUT_RIGHT_BUTTON) ((OGLCommonScene*)spCurrentScene)->mMRDown = !state;
		((OGLCommonScene*)spCurrentScene)->mMouseX = x;
		((OGLCommonScene*)spCurrentScene)->mMouseY = y;

	}
	static inline void CommonMotionFunc(int x, int y)
	{
		((OGLCommonScene*)spCurrentScene)->mDeltaX = x - ((OGLCommonScene*)spCurrentScene)->mMouseX;
		((OGLCommonScene*)spCurrentScene)->mDeltaY = y - ((OGLCommonScene*)spCurrentScene)->mMouseY;
		((OGLCommonScene*)spCurrentScene)->mMouseX = x;
		((OGLCommonScene*)spCurrentScene)->mMouseY = y;
	}
	static inline void CommonComputeBeforeDisplay()
	{
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	}

};

}