/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include "OGLDoubleTexture.h"
#include "OGLSEasyProgram.h"
#include "OGLScene.h"

namespace SSSLib
{

namespace OGLFancy2D
{

class OGLFrac: public OGLScene::OGLRenderExt
{
public:
	OGLFrac(void);
	~OGLFrac(void);

	DTex2D::Tex4ChFl mTex[2];
	DTex2D::Tex4ChFl mDrawTex;

	OGLSEasyProgram mUpdateShader;

	void Init(int iWidth, int iHeight);

	virtual void RenderFunc(SSSLib::OGLScene::TStageName stage, int pass)
	{
		if (stage == mUpdateStage && pass == mUpdatePass)
			UpdatePass();
	}
	virtual void UpdatePass();

	void BindUpdatePass(OGLScene* ipScene,SSSLib::OGLScene::TStageName iUpdateStage = SSSLib::OGLScene::PRE_PASS, int iUpdatePass = 0)
	{
		mUpdateStage = iUpdateStage;
		mUpdatePass = iUpdatePass;
		ipScene->AddRenderExt(this, iUpdateStage, iUpdatePass);
	}

	SSSLib::OGLScene::TStageName mUpdateStage;
	int mUpdatePass;
	
	int mCurLoop;
};

}

}