/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include <GL/freeglut.h>
#include <map>
#include <vector>
#include "OGLCommonScene.h"

namespace SSSLib
{

class OGLFrame: public OGLCommonScene
{
public:
	static OGLFrame* GetInstance()
	{
		if (!spOGLFrame)
			spOGLFrame = new OGLFrame();
		if (!spCurrentScene)
			spOGLFrame->UseScene();
		return spOGLFrame;
	}
	void ReleaseInstance(){if (spOGLFrame) delete spOGLFrame; spOGLFrame = NULL;}
	static inline void Init(int iWindowWidth, int iWindowHeight, const char* iWindowName = "default")
	{GetInstance()->InitWindow(iWindowWidth, iWindowHeight, iWindowName);}
protected:
	OGLFrame(void);
	~OGLFrame(void);
	static OGLFrame* spOGLFrame;

};


}