/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "OGLScene.h"
#include <string.h>

using namespace SSSLib;
using namespace std;

OGLScene* OGLScene::spCurrentScene = NULL;
int OGLScene::sWindowID = 0;

bool OGLScene::InitWindow(int iWindowWidth, int iWindowHeight,const char* iWindowName)
{
    glutInitDisplayMode( GLUT_DOUBLE | GLUT_DEPTH | GLUT_RGBA | GLUT_MULTISAMPLE );
    glutInitWindowSize( iWindowWidth, iWindowHeight );
	int tmp = 1;
	vector<char> tmpNameBuffer(strlen(iWindowName)+1);
	strcpy(&tmpNameBuffer[0], iWindowName);
	char* tmpPtr = &tmpNameBuffer[0];
	
    glutInit(&tmp, &tmpPtr);

    sWindowID = glutCreateWindow(iWindowName);
	glEnable(GL_DEPTH_TEST);

	Bind();

	return true;
}

void OGLScene::Bind()
{
	glutDisplayFunc(MultiPassRender);
	glutIdleFunc(sIdleFunc);
	glutReshapeFunc(sReshapeFunc);
	glutKeyboardFunc(sKeyboardFunc);
	glutKeyboardUpFunc(sKeyboardUpFunc);
	glutSpecialFunc(sSpecialFunc);
	glutSpecialUpFunc(sSpecialUpFunc);
	glutMouseFunc(sMouseFunc);
	glutPassiveMotionFunc(sMotionFunc);
	glutMotionFunc(sMotionFunc);
	glutMouseWheelFunc(sMouseWheelFunc);
}
