/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "OGLSimpleObj.h"
#include <GL/freeglut.h>

void SSSLib::OGLRenderCube()
{
    glBegin(GL_QUADS);
		// Front Face, red
		glNormal3f( 0.0f, 0.0f, 1.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f,  1.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f,  1.0f);
		// Back Face, green
		glNormal3f( 0.0f, 0.0f,-1.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f, -1.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f,  1.0f, -1.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f,  1.0f, -1.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, -1.0f, -1.0f);
		// Top Face, blue
		glNormal3f( 0.0f, 1.0f, 0.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f,  1.0f, -1.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f,  1.0f,  1.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f,  1.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f,  1.0f, -1.0f);
		// Bottom Face, yellow
		glNormal3f( 0.0f,-1.0f, 0.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f, -1.0f, -1.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f, -1.0f, -1.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f, -1.0f,  1.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f, -1.0f,  1.0f);
		// Right face, cyan
		glNormal3f( 1.0f, 0.0f, 0.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f, -1.0f, -1.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f, -1.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f,  1.0f,  1.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);
		// Left Face, magenta
		glNormal3f(-1.0f, 0.0f, 0.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f, -1.0f, -1.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f,  1.0f,  1.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f, -1.0f);
    glEnd();
}

void SSSLib::OGLRenderCube(SSSLib::Vec3f iCenter, float iSize)
{
    glBegin(GL_QUADS);
		// Front Face, red
		glNormal3f( 0.0f, 0.0f, 1.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-iSize+iCenter[0], -iSize+iCenter[1],  iSize+iCenter[2]);
		glTexCoord2f(1.0f, 0.0f); glVertex3f( iSize+iCenter[0], -iSize+iCenter[1],  iSize+iCenter[2]);
		glTexCoord2f(1.0f, 1.0f); glVertex3f( iSize+iCenter[0],  iSize+iCenter[1],  iSize+iCenter[2]);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-iSize+iCenter[0],  iSize+iCenter[1],  iSize+iCenter[2]);
		// Back Face, green
		glNormal3f( 0.0f, 0.0f,-1.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-iSize+iCenter[0], -iSize+iCenter[1], -iSize+iCenter[2]);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-iSize+iCenter[0],  iSize+iCenter[1], -iSize+iCenter[2]);
		glTexCoord2f(0.0f, 1.0f); glVertex3f( iSize+iCenter[0],  iSize+iCenter[1], -iSize+iCenter[2]);
		glTexCoord2f(0.0f, 0.0f); glVertex3f( iSize+iCenter[0], -iSize+iCenter[1], -iSize+iCenter[2]);
		// Top Face, blue
		glNormal3f( 0.0f, 1.0f, 0.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-iSize+iCenter[0],  iSize+iCenter[1], -iSize+iCenter[2]);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-iSize+iCenter[0],  iSize+iCenter[1],  iSize+iCenter[2]);
		glTexCoord2f(1.0f, 1.0f); glVertex3f( iSize+iCenter[0],  iSize+iCenter[1],  iSize+iCenter[2]);
		glTexCoord2f(0.0f, 1.0f); glVertex3f( iSize+iCenter[0],  iSize+iCenter[1], -iSize+iCenter[2]);
		// Bottom Face, yellow
		glNormal3f( 0.0f,-1.0f, 0.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-iSize+iCenter[0], -iSize+iCenter[1], -iSize+iCenter[2]);
		glTexCoord2f(1.0f, 0.0f); glVertex3f( iSize+iCenter[0], -iSize+iCenter[1], -iSize+iCenter[2]);
		glTexCoord2f(1.0f, 1.0f); glVertex3f( iSize+iCenter[0], -iSize+iCenter[1],  iSize+iCenter[2]);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-iSize+iCenter[0], -iSize+iCenter[1],  iSize+iCenter[2]);
		// Right face, cyan
		glNormal3f( 1.0f, 0.0f, 0.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f( iSize+iCenter[0], -iSize+iCenter[1], -iSize+iCenter[2]);
		glTexCoord2f(1.0f, 1.0f); glVertex3f( iSize+iCenter[0],  iSize+iCenter[1], -iSize+iCenter[2]);
		glTexCoord2f(0.0f, 1.0f); glVertex3f( iSize+iCenter[0],  iSize+iCenter[1],  iSize+iCenter[2]);
		glTexCoord2f(0.0f, 0.0f); glVertex3f( iSize+iCenter[0], -iSize+iCenter[1],  iSize+iCenter[2]);
		// Left Face, magenta
		glNormal3f(-1.0f, 0.0f, 0.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-iSize+iCenter[0], -iSize+iCenter[1], -iSize+iCenter[2]);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-iSize+iCenter[0], -iSize+iCenter[1],  iSize+iCenter[2]);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-iSize+iCenter[0],  iSize+iCenter[1],  iSize+iCenter[2]);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-iSize+iCenter[0],  iSize+iCenter[1], -iSize+iCenter[2]);
    glEnd();
}
