/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once
#include <GL/freeglut.h>
#include "../SSSSmallVec.h"

namespace SSSLib
{
	extern void OGLRenderCube();
	extern void OGLRenderCube(SSSLib::Vec3f iCenter, float iSize);
	template <typename t_Array>
	void OGLRenderTriangle(t_Array iVer0, t_Array iVer1, t_Array iVer2)
	{
		glBegin(GL_TRIANGLES);
			glVertex3f( iVer0[0], iVer0[1], iVer0[2]);
			glVertex3f( iVer1[0], iVer1[1], iVer1[2]);
			glVertex3f( iVer2[0], iVer2[1], iVer2[2]);
		glEnd();
	}
	template <typename t_Array>
	void OGLRenderTriangle4f(t_Array iVer0, t_Array iVer1, t_Array iVer2)
	{
		glBegin(GL_TRIANGLES);
			glVertex3f( iVer0[0], iVer0[1], iVer0[2], iVer0[3]);
			glVertex3f( iVer1[0], iVer1[1], iVer1[2], iVer1[3]);
			glVertex3f( iVer2[0], iVer2[1], iVer2[2], iVer2[3]);
		glEnd();
	}
	template <typename t_Array>
	void OGLRenderPolygon2f(t_Array iArr, int iArrSize)
	{
		glBegin(GL_POLYGON);
		for (int i=0; i<iArrSize; i++)
			glVertex2f(iArr[i][0], iArr[i][1]);
		glEnd();
	}
	inline void OGLRenderRect(float iTop, float iLeft, float iButton, float iRight)
	{
		glBegin(GL_QUADS);
			glVertex2f(iTop, iLeft);
			glVertex2f(iButton, iLeft);
			glVertex2f(iButton, iRight);
			glVertex2f(iTop, iRight);
		glEnd();
	}
	inline void OGLRenderRectTex(float iTop, float iLeft, float iButton, float iRight)
	{
		glBegin(GL_QUADS);
			glTexCoord2f(1.0f, 0.0f);		glVertex2f(iTop, iLeft);
			glTexCoord2f(0.0f, 0.0f);		glVertex2f(iButton, iLeft);
			glTexCoord2f(0.0f, 1.0f);		glVertex2f(iButton, iRight);
			glTexCoord2f(1.0f, 1.0f);		glVertex2f(iTop, iRight);
		glEnd();
	}
}
