/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include "OGLDoubleTexture.h"
#include "OGLSEasyProgram.h"
#include "OGLScene.h"

namespace SSSLib
{

namespace OGLFancy2D
{

class OGLWater2D: public OGLScene::OGLRenderExt
{
public:
	OGLWater2D(void);
	~OGLWater2D(void);
	OGLWater2D(int iWidth, int iHeight){Init(iWidth, iHeight);}

	void Init(int iWidth, int iHeight);

	DTex2D::Tex4ChFl mWaveTex[2]; 
	OGLSEasyProgram mInitShader;
	OGLSEasyProgram mUpdateShader;
	OGLSEasyProgram mRenderShader;
	int mCurLoop;

	virtual void RenderFunc(SSSLib::OGLScene::TStageName stage, int pass);
	virtual void UpdatePass();
	virtual void RenderPass();
	virtual void RainDrop(float iDelta, float iWeight, SSSLib::Vec2i iPst);

	void BindUpdatePass(OGLScene* ipScene,SSSLib::OGLScene::TStageName iUpdateStage = SSSLib::OGLScene::PRE_PASS, int iUpdatePass = 0)
	{
		mUpdateStage = iUpdateStage;
		mUpdatePass = iUpdatePass;
		ipScene->AddRenderExt(this, iUpdateStage, iUpdatePass);
	}
	
	void BindRenderPass(OGLScene* ipScene,SSSLib::OGLScene::TStageName iRenderStage = SSSLib::OGLScene::RENDER_PASS, int iRenderPass = 0)
	{
		mRenderStage = iRenderStage;
		mRenderPass = iRenderPass;
		ipScene->AddRenderExt(this, iRenderStage, iRenderPass);
	}

	void BindBottonTex(OGLTexture2D* iTex)
	{
		mpButtonTex = iTex;
	}
	
protected:
	SSSLib::OGLScene::TStageName mUpdateStage;
	int mUpdatePass;
	SSSLib::OGLScene::TStageName mRenderStage;
	int mRenderPass;
	OGLTexture2D* mpButtonTex;
	bool mIsUpdated;
};

}
}