/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include "SSSMesh.h"
#include <carve\carve.hpp>

namespace SSSLib
{
	typedef carve::poly::Vertex<3> CVtx3;
	typedef carve::poly::Face<3> CFace;
	typedef carve::poly::Edge<3> CEdge;
	extern void Carve2S3(const std::vector<CFace>& iCFace,
					SSSMesh& oS3Mesh);
	extern void S32Carve(const SSSMesh& iS3Mesh,
		std::vector<CVtx3>& oCVtx,
		std::vector<CFace>& oCFace);

	extern void S3Intersect(const SSSMesh& iS3Mesh0,
							const SSSMesh& iS3Mesh1,
							SSSMesh& oS3Mesh);

	extern carve::poly::Polyhedron* S3Intersect(const SSSMesh& iS3Mesh0,
							const SSSMesh& iS3Mesh1);
}