/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <gl\glew.h>
#include "..\SSSLibOGL\OGLFrame.h"
#include "..\SSSLibOGL\OGLCamModel.h"
#include "..\SSSLibOGL\OGLSimpleObj.h"
#include "..\SSSLibOGL\OGLTexture.h"
#include "..\SSSLibOGL\OGLSEasyProgram.h"
#include "..\SSSSmallVec.h"
//#include "..\SSSSimpleSpline.h"
#include <iostream>
//#include "..\..\ShapeTransform\ShapeTransform2DLib\Shape2DMatch.h"
//#include <CGAL/Exact_predicates_exact_constructions_kernel.h>

using namespace SSSLib;
using namespace std;

//Shape2DSpline gTestObj;

OGLCamModel* g_testCam;
OGLTexture2D g_texture;
OGLSEasyProgram* g_pProgram;

struct anyway
{
	int a;
	int b;
	anyway(int ia, int ib): a(ia), b(ib){}
	anyway(){}
	anyway operator+(const anyway& iv) const
	{
		return anyway(a+iv.a, b+iv.b);
	}
};

void TestRender(OGLScene::TStageName, int)
{
	g_testCam->SetProjMatrix();
	g_testCam->SetViewMatrix();
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	//g_texture.Bind(true, 0);
	//glUniform1i(g_pProgram->GetUniformLocation("myTexture0"), g_texture.GetID());
	g_pProgram->BindTexture("myTexture0", g_texture, 0);
	OGLRenderCube();
	glFlush();
	glutSwapBuffers();
	int err = glGetError();
	if (err>0)
		std::cout<<"Drawing Error:"<<err<<std::endl;

}

void main(int argc, char** argv)
{
	SmallVec<float,2> v1(1,1),v2(1,0);
	cout<<"size of float*2 "<<sizeof(v1)<<endl;
	v1+=v2;
	v1=v1+v2;
	v1+=1;
	v1=1+v1;

	SmallVec<anyway,2> av1,av2;
	av1=av1+av2;

	OGLFrame::Init(640,480);
	//OGLFrame::GetInstance()->SetCommonFunction();
	OGLFrame::GetInstance()->AddRenderExt(TestRender);
	OGLFrame::GetInstance()->EnableIdleRender();
	g_testCam = new OGLCamModel();
	g_testCam->EnableCam(OGLFrame::GetInstance());

	g_texture.LoadFromFile("pic2.png");

	glewInit();
	g_pProgram = new OGLSEasyProgram(NULL,"fragmentshader.txt");
	g_pProgram->Use();
	glutMainLoop();
}
