/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include <opencv\cxcore.h>
#include <fstream>

namespace SSSLib
{
	inline void WriteMat(const cv::Mat& iMat, std::ofstream& oFile)
	{
		int matType = iMat.type();
		oFile.write((char*)&iMat.rows, 4);
		oFile.write((char*)&iMat.cols, 4);
		oFile.write((char*)&matType, 4);
		oFile.write((char*)iMat.data, iMat.elemSize() * iMat.rows * iMat.cols);
	}
	inline void WriteMat(const cv::Mat& iMat, const char* oFileName)
	{
		std::ofstream oFile(oFileName, std::ios_base::binary);
		WriteMat(iMat, oFile);
	}
	inline cv::Mat ReadMat(std::ifstream& iFile)
	{
		int matType;
		int rows;
		int cols;
		iFile.read((char*)&rows, 4);
		iFile.read((char*)&cols, 4);
		iFile.read((char*)&matType, 4);
		cv::Mat retMat(rows, cols, matType);
		iFile.read((char*)retMat.data, retMat.elemSize() * retMat.rows * retMat.cols);
		return retMat;
	}
	inline cv::Mat ReadMat(const char* iFileName)
	{
		std::ifstream iFile(iFileName, std::ios_base::binary);
		return ReadMat(iFile);
	}
}