/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include <opencv\cxcore.h>
#include <vector>

namespace SSSLib
{
	template <typename _TVal>
	std::vector<std::vector<_TVal> > Mat2Vec(const cv::Mat& iMat)
	{
		using namespace std;
		vector<vector<_TVal> > retVec(iMat.rows);
		for (int r=0; r<iMat.rows; r++)
		{
			retVec[r].resize(iMat.cols);
			for (int c=0; c<iMat.cols; c++)
				retVec[r][c] = iMat.at<_TVal>(r, c);
		}
		return retVec;
	}
}