/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include "SSSSmallVec.h"
#include <vector>
#include <opencv\cxcore.h>
#include <numeric>

namespace SSSLib
{

class SSSSimpleSpline
{
public:
	SSSSimpleSpline(void): mIsClosed(true){}
	~SSSSimpleSpline(void){}
	std::vector<SSSLib::Vec2d> mCtrPt;
	SSSLib::Vec2d GetPoint(int i, double iS);
	SSSLib::Vec2d GetPoint(double iS){return GetPoint((int)floor(iS), iS-floor(iS));}
	SSSLib::Vec2d GetGradient(double iS);
	SSSLib::Vec2d GetNormal(double iS);
	std::vector<SSSLib::Vec2d> BuildLine(double iBegS, double iEndS, int iReso);
	void ComputePT(int i, SSSLib::Vec2d& p0, SSSLib::Vec2d& p1, SSSLib::Vec2d& t0, SSSLib::Vec2d& t1);
	std::vector<double> ApproxLength(int iSegs);
	cv::Mat Draw(int iReso);
	void InsertPt(SSSLib::Vec2d iPt);

	bool mIsClosed;
};

}