/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include "SSSSmallVec.h"
#include "SSSFunc.h"
#include <opencv\cxcore.h>

namespace SSSLib
{
	template <typename _TVec>
	bool within(const cv::Mat &iMat, _TVec iVec)
	{
		return within(iVec[0], 0, iMat.cols-1) && within(iVec[1], 0, iMat.rows-1);
	}

	template <typename _TMatEle, typename _TVec>
	_TMatEle& Get(cv::Mat& iMat, _TVec iVec)
	{
		return iMat.at<_TMatEle>(iVec[1], iVec[0]);
	}

	template <typename _TMatEle, typename _TVec>
	const _TMatEle& Get(const cv::Mat& iMat, _TVec iVec)
	{
		return iMat.at<_TMatEle>(iVec[1], iVec[0]);
	}
}