#include "..\StaticFEM\Static2d.h"

#include <gl\glew.h>
#include "..\SSSLib\SSSLibOGL\OGLFrame.h"
#include "..\SSSLib\SSSLibOGL\OGLCamModel.h"
#include "..\SSSLib\SSSLibOGL\OGLSimpleObj.h"
#include "..\SSSLib\SSSLibOGL\OGLTexture.h"
#include "..\SSSLib\SSSLibOGL\OGLSEasyProgram.h"
#include "..\SSSLib\SSSSmallVec.h"
#include <iostream>
//#include "..\FEMLib\FEMObj.h"
#include <Windows.h>
#include <GL\freeglut.h>

using namespace SSSLib;
using namespace std;

OGLCamModel* g_testCam;
OGLSEasyProgram* g_pProgram;
Static2D gFEM;

int gWindowHeight = 500;

void TestRender(OGLScene::TStageName, int)
{

//	g_testCam->SetProjMatrix();
//	g_testCam->SetViewMatrix();
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glViewport(0, 0, gWindowHeight, gWindowHeight);

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glColor3f(0, 0, 1.0f);

	glBegin(GL_LINES);
		for (int i=0; i<(int)gFEM.mTriangles.size(); i++)
		for (int j=0; j<3; j++)
		{
			glVertex2dv((double*)&(gFEM.mRest[gFEM.mTriangles[i][j]]));	//glTexCoord2dv((double*)&(gFEM.mRest[gFEM.mTriangles[i][j]]));
			glVertex2dv((double*)&(gFEM.mRest[gFEM.mTriangles[i][(j+1)%3]]));	//glTexCoord2dv((double*)&(gFEM.mRest[gFEM.mTriangles[i][k]]));
		}
	glEnd();
	
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glViewport(gWindowHeight, 0, gWindowHeight, gWindowHeight);

	glBegin(GL_LINES);
		for (int i=0; i<(int)gFEM.mTriangles.size(); i++)
		for (int j=0; j<3; j++)
		{
			glVertex2dv((double*)&(gFEM.mStatic[gFEM.mTriangles[i][j]]));	//glTexCoord2dv((double*)&(gFEM.mRest[gFEM.mTriangles[i][j]]));
			glVertex2dv((double*)&(gFEM.mStatic[gFEM.mTriangles[i][(j+1)%3]]));	//glTexCoord2dv((double*)&(gFEM.mRest[gFEM.mTriangles[i][k]]));
		}
	glEnd();

	glFlush();
	glutSwapBuffers();
	int err = glGetError();
	if (err>0)
		std::cout<<"Drawing Error:"<<err<<std::endl;
}

void Keyboard(unsigned char iKey, int x, int y)
{

}

void main(int argc, char** argv)
{

	OGLFrame::Init(gWindowHeight*2,gWindowHeight);
	//OGLFrame::GetInstance()->SetCommonFunction();
	OGLFrame::GetInstance()->AddRenderExt(TestRender);
	OGLFrame::EnableIdleRender();
	//OGLFrame::GetInstance()->AddKey0board(
	g_testCam = new OGLCamModel();
	g_testCam->EnableCam(OGLFrame::GetInstance());

	gFEM.InitRect(6, 6, 0.15);
	gFEM.InitParam(2e3, 0.3f);
	//for (int i=0; i<(int)gFEM.mForce.size(); i++)
	//	gFEM.mForce[i] = Vec2Float(0, -9.8f);
	gFEM.mForce[0] = Vec2Float(0, -10.0f);
	gFEM.mForce[5] = Vec2Float(0, -10.0f);
	//gFEM.mForce[30] = Vec2Float(0, -10.0f);
	//gFEM.mForce[5] = Vec2Float(-10.0f, 0);
	//gFEM.mForce[33] = Vec2Float(0, 10.0f);
	//gFEM.mForce[32] = Vec2Float(0, 9.8f);
	//gFEM.mForce[35] = Vec2Float(0, -9.8f);
	gFEM.mFixedVtx[30] = 1;
	gFEM.mFixedVtx[31] = 1;
	gFEM.mFixedVtx[32] = 1;
	gFEM.mFixedVtx[33] = 1;
	gFEM.mFixedVtx[34] = 1;
	gFEM.mFixedVtx[35] = 1;
	gFEM.Compute();
	cout<<"Length\t"<<gFEM.mRest[gFEM.mRest.size()-1]-gFEM.mRest[0]<<endl;
	//glewInit();
	//g_pProgram = new OGLSEasyProgram(NULL,"restshader.txt");
	//g_pProgram->Use();
	glutMainLoop();
}
