/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include "..\StaticFEM\Config.h"
#include "..\SSSLib\SSSSmallVec.h"
#include <float.h>

namespace ADMMLib
{
	inline void Encode(SVec2Float* iVec, int iSize, _T_FLOAT* oVec)
	{
		for (int i=0; i<iSize; i++)
		{
			oVec[i*2] = iVec[i][0];
			oVec[i*2+1] = iVec[i][1];
		}
	}

	inline void Decode(_T_FLOAT* iVec, int iSize, SVec2Float* oVec, SSSLib::Vec2b* oFixed = NULL)
	{
		for (int i=0; i<iSize; i++)
		{
			oVec[i][0] = iVec[i*2];
			oVec[i][1] = iVec[i*2+1];

			if (oFixed)
			{
				if (!_finite(iVec[i*2]))
				{
					oVec[i][0] = 0;
					oFixed[i][0] = 1;
				}
				else
					oFixed[i][0] = 0;

				if (!_finite(iVec[i*2+1]))
				{
					oVec[i][1] = 0;
					oFixed[i][1] = 1;
				}
				else
					oFixed[i][1] = 0;
			}
		}
	}
}