/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include "../StaticFEM/Config.h"

inline Mat3x3 Vec2Mat3x3(const MatXFloat& iMat)
{
	Mat3x3 retMat;
	for (int k=0; k<9; k++)
		retMat(k/3, k%3) = iMat(k, 0);
	return retMat;
}

inline MatXFloat Mat3x3ToVec(const Mat3x3& iMat)
{
	MatXFloat retVec(9, 1);
	for (int k=0; k<9; k++)
		retVec(k, 0) = iMat(k/3, k%3);
	return retVec;
}