/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "PhysImpSolve3D.h"

using namespace std;
using namespace SSSLib;

bool PhysImpSolve3D::NoiseBranch()
{
	cout<<"Before Branching Value:"<<mFuncVal<<endl;
	Backup(mBreakPoint);

	for (int i=0; i<(int)mX0.size(); i++)
	for (int c=0; c<3; c++)
	{
		mX0[i][c] += (randf<_T_FLOAT>()*2-1)*mNoiseScale;
	}
	mP0 = mX0;

	RunPhysics();

	if (!lbPhysValid)
	{
		Rollback(mBreakPoint);
		return false;
	}
	else
	{
		mFuncVal = CalScoreWithPen();
		Backup(mStepBK);
		return true;
	}
}

void PhysImpSolve3D::NoiseMerge()
{
	cout<<"Before Merging Value:"<<mFuncVal
		<<"\tOrigin:"<<mBreakPoint.mLastFuncVal<<endl;
	if (mBreakPoint.mLastFuncVal<mFuncVal)
	{
		Rollback(mBreakPoint);
		Backup(mStepBK);
	}
	cout<<"After Merging Value:"<<mFuncVal<<endl;
}