/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "PhysImpSolve3D.h"
#include <Eigen/Eigenvalues>
#include <omp.h>

using namespace SSSLib;
using namespace std;

//void PhysImpSolve3D::ComputeVolumeConst()
//{
//	int poffset = mX0.size()*3;
//
//	for (int eleType=0; eleType<2; eleType++)
//	{
//		int eleNum;
//		int eleSize;
//		vector<MatXFloat, Eigen::aligned_allocator<MatXFloat> > h;
//		switch (eleType)
//		{
//		case 0:
//			eleNum = mpVolMesh->mTets.size();
//			eleSize = 4;
//			h.resize(1);
//			h[0] = HexBuildH(SVec3Float(0, 0, 0), eleSize);
//			break;
//		case 1:
//			eleNum = mpVolMesh->mHexs.size();
//			eleSize = 8;
//			h.resize(8);
//			for (int i=0; i<8; i++)
//			{
//				SVec3Float coord(i&1, (i>>1)&1, (i>>2)&1);
//				coord = coord*2-1;
//				coord = coord/sqrt(3);
//				//coord[0] = -coord[0];
//				h[i] = HexBuildH(coord, 8);
//			}
//			break;
//		}
//
//#pragma omp parallel for
//		for (int t=0; t<eleNum; t++)
//		{
//			vector<int> ele(eleSize);
//			if (eleType==0)
//				for (int i=0; i<eleSize; i++)
//					ele[i] = mpVolMesh->mTets[t][i];
//			else
//				for (int i=0; i<eleSize; i++)
//					ele[i] = mpVolMesh->mHexs[t][i];
//			assert(eleSize<=8);
//			Vec3Float x0[8];
//			Vec3Float p0[8];
//			Vec3Float x1[3];
//			Vec3Float p1[3];
//			for (int i=0; i<eleSize; i++)
//			{
//				x0[i] = Vec3Float(mX0[ele[i]].val);
//				p0[i] = Vec3Float(mP0[ele[i]].val);
//			}
//
//			for (int testPt = 0; testPt<(int)h.size(); testPt++)
//			{
//				HexEncode(x0, p0, h[testPt], x1, p1);
//				Mat3x3 X;
//				Mat3x3 P;
//				for (int i=0; i<3; i++)
//				{
//					X.col(i) = x1[i];
//					P.col(i) = p1[i];
//				}
//
//				Mat3x3 dM;
//				MatXFloat d2M;
//
//				Det2ndOrder(X, dM, d2M);
//				_T_FLOAT det = -X.determinant();
//				MatXFloat dV = MatXFloat::Zero(18, 1);
//				MatXFloat d2V = MatXFloat::Zero(18, 18);
//				for (int r=0; r<3; r++)
//				for (int c=0; c<3; c++)
//					dV(r+c*3, 0) = -dM(r, c);
//
//				for (int r1=0; r1<3; r1++)
//				for (int c1=0; c1<3; c1++)
//				for (int r2=0; r2<3; r2++)
//				for (int c2=0; c2<3; c2++)
//					d2V(r1+c1*3, r2+c2*3) = -d2M(r1*3+c1, r2*3+c2);
//				
//				MatXFloat dV2;
//				MatXFloat d2V2;
//
//				if (eleSize==4)
//					Hex2ndOrderDecode<4>(dV, d2V, h[testPt], dV2, d2V2);
//				else
//					Hex2ndOrderDecode<8>(dV, d2V, h[testPt], dV2, d2V2);
//
//				vector<int> idx(eleSize*6);
//				for (int xp=0; xp<2; xp++)
//				for (int v=0; v<eleSize; v++)
//				for (int c=0; c<3; c++)
//				{
//					idx[(xp*eleSize+v)*3+c] = poffset*xp+ele[v]*3+c;
//				}
//				MatXFloat grad = dV2*mVMWeight*mXMassScale;
//				MatXFloat hess = d2V2*mVMWeight*mXMassScale;
//				assert(grad.rows()==eleSize*3*2);
//				vector<_T_FLOAT> gradvec(grad.rows());
//				for (int k=0; k<(int)gradvec.size(); k++)
//					gradvec[k] = grad(k, 0);
//			#pragma omp critical
//				{
//					AddInequalityConstraint(det*mVMWeight*mXMassScale, idx.size(), &idx[0], NULL, &gradvec[0], hess);
//				}
//			}
//		}
//	}
//}

void PhysImpSolve3D::ComputeVMForce(bool ibComputeUOnly, ConttForce iCont)
{
	//if (mS==0 & mPhase==1)
	//{
	//	KKTEle newKKT;
	//	newKKT.AddACoe(mX0.size()*6, 1);
	//	newKKT.mB = 0;
	//	mKKT.push_back(newKKT);
	//}

	mVM.resize(mpVolMesh->mTets.size());
	typedef Eigen::Triplet<_T_FLOAT> T;
	int poffset = int(mX0.size())*3;

	MatXFloat vmmat;
	MatXFloat vmcore = MatXFloat::Zero(6, 6);
	for (int i=0; i<3; i++)
	{
		vmcore(i, i) = 2;
		vmcore(i+3, i+3) = 6;
		for (int j=i+1; j<3; j++)
		{
			vmcore(i, j) = -1;
			vmcore(j, i) = -1;
		}
	}
	vmcore *= 0.5;
	vmmat = MatXFloat(mE).transpose()*vmcore*mE;

	//vmmat = MatXFloat::Identity(6, 6)*1e6;

	// for debug
	//{
	//	cout<<"vmmaat\n"
	//		<<vmmat<<endl;
	//	Eigen::EigenSolver<MatXFloat> eigenVal(vmmat);
	//	cout<<"Eigenvalues\n"
	//		<<eigenVal.eigenvalues()<<endl;
	//}

	for (int eleType=0; eleType<2; eleType++)
	{
		int eleNum;
		int eleSize;
		vector<MatXFloat, Eigen::aligned_allocator<MatXFloat> > h;
		switch (eleType)
		{
		case 0:
			eleNum = mpVolMesh->mTets.size();
			eleSize = 4;
			h.resize(1);
			h[0] = HexBuildH(SVec3Float(0, 0, 0), eleSize);
			break;
		case 1:
			eleNum = mpVolMesh->mHexs.size();
			eleSize = 8;
			h.resize(8);
			for (int i=0; i<8; i++)
			{
				SVec3Float coord(i&1, (i>>1)&1, (i>>2)&1);
				coord = coord*2-1;
				coord = coord/sqrt(3);
				//coord[0] = -coord[0];
				h[i] = HexBuildH(coord, 8);
			}
			break;
		}

#pragma omp parallel for
		for (int t=0; t<eleNum; t++)
		{
			vector<int> ele(eleSize);
			if (eleType==0)
				for (int i=0; i<eleSize; i++)
					ele[i] = mpVolMesh->mTets[t][i];
			else
				for (int i=0; i<eleSize; i++)
					ele[i] = mpVolMesh->mHexs[t][i];
			assert(eleSize<=8);
			Vec3Float x0[8];
			Vec3Float p0[8];
			Vec3Float x1[3];
			Vec3Float p1[3];
			for (int i=0; i<eleSize; i++)
			{
				x0[i] = Vec3Float(mX0[ele[i]].val);
				p0[i] = Vec3Float(mP0[ele[i]].val);
			}

			for (int testPt = 0; testPt<(int)h.size(); testPt++)
			{

				HexEncode(x0, p0, h[testPt], x1, p1);

				_T_FLOAT refVol = 0;

				_T_FLOAT U = 0;
				if (iCont == ContVM)
				{
					bool bNegV;
					U = ComputeU(x1, p1, vmmat, true, &bNegV);
#ifndef _USE_NEG_VOL
					if (bNegV)
						lbPhysValid = false;
#endif
				// for debug
				//{
				//	Vec3Float x2[3];
				//	Vec3Float p2[3];

				//	for (int i=0; i<3; i++)
				//	for (int c=0; c<3; c++)
				//	{
				//		x2[i][c] = x1[i][(c+1)%3];
				//		p2[i][c] = p1[i][(c+1)%3];
				//	}
				//	_T_FLOAT U3 = ComputeU(x2, p2, vmmat, true);
				//	assert(fabs(U-U3)<=max(U, U3)*1e-6);
				//}
					if (eleType==0)
						mVM[t] = U;
					else
						mVMHex[t][testPt] = U;
				}
				else if (iCont == InitJac)
				{
					Mat3x3 X;
					for (int i=0; i<3; i++)
						X.col(i) = x1[i];
					U = X.determinant();
					if (eleType==0)
						mJacRef[t] = U;
					else
						mJacRefHex[t][testPt] = U;
				}
				else if (iCont == ContVolume)
				{
					if (eleType==0)
						refVol = mJacRef[t]*mJacPercentBound;
					else
						refVol = mJacRefHex[t][testPt]*mJacPercentBound;
					Mat3x3 X;
					for (int i=0; i<3; i++)
						X.col(i) = x1[i];
					U = X.determinant();
					//if (eleType==0)
					//	mJac[t] = 1-U/refVol;
					//else
					//	mJacHex[t][testPt] = 1-U/refVol;
					if (eleType==0)
						mJac[t] = refVol-U;
					else
						mJacHex[t][testPt] = refVol-U;
				}
				if ((iCont==ContVolume && U<refVol && !ibComputeUOnly)
					||
					(iCont==ContVM
					&& (!ibComputeUOnly && mVMWeight>0 && (U>mVMBound || mPhase!=-1))
					&& (U>mVMBound || !lbNoExtraVM)
					)
					)
				{
					_T_FLOAT U2;
					MatXFloat dU;
					MatXFloat d2U;

					_T_FLOAT w;
					bool isVol;

					switch (iCont)
					{
					case ContVM:
						{
							Mat3x3 X;
							for (int i=0; i<3; i++)
								X.col(i) = x1[i];
#ifdef _USE_NEG_VOL
							if (1)
#else
							if (X.determinant()>0)
#endif
							{
								U2ndOrder(x1, p1, vmmat, true, U2, dU, d2U);
								U2 -= mVMBound;
								w = mVMWeight;
								isVol = false;
							}
							else
							{
								Volume2ndOrder(x1, p1, U2, dU, d2U);
								w = mVolumeWeight;
								isVol = true;
								lbPhysValid = false;
							}
							break;
						}
					case ContVolume:
						{
							Volume2ndOrder(x1, p1, U2, dU, d2U);
							U2 = refVol+U2;
							//assert(U==U2);
							//w = mVolumeWeight/refVol;
							w = mVolumeWeight;
							isVol = true;
							break;
						}
					}

					MatXFloat dU2;
					MatXFloat d2U2;

					if (eleSize==4)
						Hex2ndOrderDecode<4>(dU, d2U, h[testPt], dU2, d2U2);
					else
						Hex2ndOrderDecode<8>(dU, d2U, h[testPt], dU2, d2U2);

					//assert(isVol || fabs(U-mVMBound-U2)<=Max(mVMBound, fabs(U))*1e-3);

					vector<int> idx(eleSize*6);
					vector<int> bOpt(idx.size());
					for (int xp=0; xp<2; xp++)
					for (int v=0; v<eleSize; v++)
					for (int c=0; c<3; c++)
					{
						idx[(xp*eleSize+v)*3+c] = poffset*xp+ele[v]*3+c;
						bOpt[(xp*eleSize+v)*3+c] = !xp;
					}
					MatXFloat grad = dU2*w*mXMassScale;
					MatXFloat hess;
					if (!lFirstOrderOnly)
						hess = d2U2*w*mXMassScale;
					assert(grad.rows()==eleSize*3*2);
					vector<_T_FLOAT> gradvec(grad.rows());
					for (int k=0; k<(int)gradvec.size(); k++)
						gradvec[k] = grad(k, 0);
			#pragma omp critical
					{
						AddInequalityConstraint(U2*w*mXMassScale, idx.size(), &idx[0], &bOpt[0], &gradvec[0], hess);
					}
				}
			}
		}
	}
}

_T_FLOAT PhysImpSolve3D::ComputeMaxVM() const
{
	_T_FLOAT maxVM = -1;
	for (int i=0; i<(int)mVM.size(); i++)
		maxVM = max(maxVM, mVM[i]);
	for (int i=0; i<(int)mVMHex.size(); i++)
	for (int j=0; j<mVMHex[i].size; j++)
		maxVM = max(maxVM, mVMHex[i][j]);
	return maxVM;
}

void PhysImpSolve3D::ComputeVMPerVtx()
{
	std::vector<_T_FLOAT> weight(mX0.size(), 0);
	mVMVtx.assign(mX0.size(), 0);

	if (mVM.size()>0)
	for (int t=0; t<(int)mpVolMesh->mTets.size(); t++)
	{
		Vec4i tet = mpVolMesh->mTets[t];
		for (int v=0; v<4; v++)
		{
			Vec3d edges[3];
			for (int v2=1; v2<=3; v2++)
				edges[v2-1] = mX0[tet[(v+v2)%4]]-mX0[tet[v]];

			if (v%2==1)
				swap(edges[0], edges[1]);

			// for debug 
			{
				double triple = TripleProduct<double>(edges[0], edges[1], edges[2]);
				if (triple<0)
					cout<<"!";
			}
			double w = SSSVolMesh::SolidAnge(edges);
			
			mVMVtx[tet[v]] += w*mVM[t];
			weight[tet[v]] += w;
		}
	}

	if (mVMHex.size()>0)
	for (int h=0; h<(int)mpVolMesh->mHexs.size(); h++)
	{
		SSSVolMesh::_THex hex = mpVolMesh->mHexs[h];
		for (int v=0; v<8; v++)
		{
			Vec3d edges[3];
			for (int v2=0; v2<3; v2++)
			{
				int vv = v ^ (1<<v2);
				edges[v2] = mX0[hex[vv]]-mX0[hex[v]];
			}

			if ((v&1)^((v>>1)&1)^((v>>2)&1))
				swap(edges[0], edges[1]);

			// for debug 
			{
				double triple = TripleProduct<double>(edges[0], edges[1], edges[2]);
				if (triple<0)
					cout<<"!";
			}

			double w = SSSVolMesh::SolidAnge(edges);
			
			mVMVtx[hex[v]] += w*mVMHex[h][v];
			weight[hex[v]] += w;
		}
	}

	for (int i=0; i<(int)mVMVtx.size(); i++)
	if (weight[i]>0)
		mVMVtx[i] /= weight[i];
	else
		mVMVtx[i] = 0;
}

void PhysImpSolve3D::UpdateVMBound(_T_FLOAT iNewVMBound, _T_FLOAT iS, bool ibUpdateNewtonT, bool ibNoIS)
{
	_T_FLOAT maxVM = ComputeMaxVM();
	mVMBound = iNewVMBound;
	_T_FLOAT updateS = (maxVM-mVMBound)*mVMWeight;
	//if (maxVM<iNewVMBound)
	//{
	//	mPhase = -1;
	//	return;
	//}
	//if (maxVM>iNewVMBound)
	{
		if (ibNoIS)
			iS = mS;
		//if (mPhase!=1 || maxVM-iNewVMBound>=mS)
		{
			//if (iS<0 && maxVM<mVMBound)
			//{
			//	mS = 0;
			//	mVS = 0;
			//}
			//else
			
			if (iS<updateS || ibUpdateNewtonT)
			{
				//if (mS<updateS)
				{
					//ibUpdateNewtonT = true;
					_T_FLOAT delta;
					if (ibUpdateNewtonT)
						delta = 0.01*mVMBound*mVMWeight/mNewtonTInitScale;
					else
						delta = 0.01*mVMBound*mVMWeight/mNewtonT;
					mS = updateS+delta;
				}
				mVS = 0;
				//if (iS>0)
				//	ibUpdateNewtonT = true;
			}
			//else if (updateS>0 && iS>updateS*2)
			//{
			//	mS = updateS*1.01;
			//	mVS = 0;
			//	ibUpdateNewtonT = true;
			//}
			else
				mS = iS;
		}
	}

	if (mPhase!=1 && maxVM>mVMBound)
		mPhase = 1;

	if (ibUpdateNewtonT)
		//mNewtonT = _T_FLOAT(mpVolMesh->mHexs.size()+mpVolMesh->mTets.size())*mNewtonTInitScale;
		mNewtonT = mNewtonTInitScale;

	mNewtonSScale = (mS-Max<_T_FLOAT>(updateS, 0));

	// for debug
	//cout<<"Max VM:"<<maxVM<<endl;
	//mPhase = -1;
}