/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include "..\ADMMLib\ADMM.h"
#include "..\StaticFEM\Static2D.h"
#include "XNodeF.h"
#include "XNodeVM.h"

namespace ADMMLib
{

class Static2DADMM : public ADMM
{
public:
	Static2DADMM(void);
	~Static2DADMM(void);

	Static2D* mpFEM2D;

	std::vector<ZNode*> mZRest;
	std::vector<ZNode*> mZStatic;
	std::vector<ZNode*> mZTriangleForce;
	std::vector<ZNode*> mZVM;

	std::vector<XNodeF*> mpXNodeF;
	std::vector<XNodeVM*> mpXNodeVM;

	_T_FLOAT mMaxVM;
	_T_FLOAT mForceScale;
	_T_FLOAT mVMScale;

	//std::vector<XNodeF*> mXForce;

	void SetupGraph();
	void CopyInitialValue();
	void UpdateResult(bool ibRest, bool ibStatic);
	void Restart();
};

}