/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "XNodeFSum.h"
#include "ADMMUtil.h"
#include "..\ADMMLib\ADMM.h"

using namespace std;
using namespace ADMMLib;

XNodeFSum::XNodeFSum(void)
{
}

XNodeFSum::~XNodeFSum(void)
{
}

void XNodeFSum::Init()
{
	m_x.resize(mp_z.size());
	m_n.resize(mp_z.size());
	m_u.resize(mp_z.size());
	m_rhoIn.resize(mp_z.size());
	m_rhoOut.resize(mp_z.size());

	mtF.resize(m_x.size()/2);
	mtF0.resize(m_x.size()/2);
	mtRho.resize(m_x.size()/2);
	mtFixed.resize(m_x.size()/2);
}

void XNodeFSum::SolveX()
	// assuming equal rho
{
	Decode();
	for (int i=0; i<2; i++)
	{
		_T_FLOAT xdotv = 0;
		_T_FLOAT vdotv = (_T_FLOAT)mtF.size();
		for (int j=0; j<(int)mtF.size(); j++)
		{
			xdotv += mtF0[j][i];
		}
		_T_FLOAT lambda = (mExtF[i]-xdotv)/vdotv;
		for (int j=0; j<(int)mtF.size(); j++)
			mtF[j][i] = mtF0[j][i]+lambda;
	}
	Encode();
}

void XNodeFSum::Encode()
{
	ADMMLib::Encode(&mtF[0], (int)mtF.size(), &m_x[0]);
	for (int i=0; i<(int)m_rhoOut.size(); i++)
		m_rhoOut[i] = mpADMM->mRho;
}

void XNodeFSum::Decode()
{
	ADMMLib::Decode(&m_n[0], (int)mtF0.size(), &mtF0[0]);
	ADMMLib::Decode(&m_rhoIn[0], (int)mtRho.size(), &mtRho[0], &mtFixed[0]);
}

