/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

//#define FLOAT32

//#define _USE_MATLAB

#ifdef FLOAT32
#	define _T_FLOAT float
#	define CV_VAL_TYPE CV_32F
#	define Vec3Float Eigen::Vector3f
#	define Mat3x3 Eigen::Matrix3f
#	define MatXFloat MatrixXf
#	define Mat2x2 Eigen::Matrix2f
#else
#	define _T_FLOAT double
#	define CV_VAL_TYPE CV_64F
#	define Vec4Float Eigen::Vector4d
#	define Vec3Float Eigen::Vector3d
#	define Vec2Float Eigen::Vector2d
#	define SVec2Float SSSLib::Vec2d
#	define SVec3Float SSSLib::Vec3d
#	define SVec4Float SSSLib::Vec4d
#	define Mat3x3 Eigen::Matrix3d
#	define Mat4x4 Eigen::Matrix4d
#	define MatXFloat Eigen::MatrixXd
#	define Mat2x2 Eigen::Matrix2d
#	define SMat2x2 SSSLib::Mat2x2d
#	define SMat3x3 SSSLib::Mat3x3d
#	define SMat4x4 SSSLib::Mat4x4d
#	define VectorXFloat Eigen::VectorXd
#endif

#include <Eigen/Dense>
#include <Eigen/StdVector>
#include "../SSSLib/SSSSmallVec.h"
#include "../SSSLib/SSSSmallMat.h"

typedef Eigen::Matrix<_T_FLOAT, 6, 1> Vec6Float;
typedef Eigen::Matrix<_T_FLOAT, 6, 6> Mat6x6;