/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "Static2d.h"

#include <gl\glew.h>
#include "..\SSSLib\SSSLibOGL\OGLFrame.h"
#include "..\SSSLib\SSSLibOGL\OGLCamModel.h"
#include "..\SSSLib\SSSLibOGL\OGLSimpleObj.h"
#include "..\SSSLib\SSSLibOGL\OGLTexture.h"
#include "..\SSSLib\SSSLibOGL\OGLSEasyProgram.h"
#include "..\SSSLib\SSSSmallVec.h"
#include <iostream>
//#include "..\FEMLib\FEMObj.h"

using namespace SSSLib;
using namespace std;

OGLCamModel* g_testCam;
OGLSEasyProgram* g_pProgram;
Static2D gFEM;

void TestRender(OGLScene::TStageName, int)
{

	g_testCam->SetProjMatrix();
	g_testCam->SetViewMatrix();
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glColor3f(0, 0, 1.0f);

	glBegin(GL_LINES);
		for (int i=0; i<(int)gFEM.mTriangles.size(); i++)
		for (int j=0; j<3; j++)
		{
//			glVertex2dv((double*)&(gFEM.mRest[gFEM.mTriangles[i][j]]));	//glTexCoord2dv((double*)&(gFEM.mRest[gFEM.mTriangles[i][j]]));
//			glVertex2dv((double*)&(gFEM.mRest[gFEM.mTriangles[i][(j+1)%3]]));	//glTexCoord2dv((double*)&(gFEM.mRest[gFEM.mTriangles[i][k]]));

			glVertex2dv((double*)&(gFEM.mStatic[gFEM.mTriangles[i][j]]));	//glTexCoord2dv((double*)&(gFEM.mRest[gFEM.mTriangles[i][j]]));
			glVertex2dv((double*)&(gFEM.mStatic[gFEM.mTriangles[i][(j+1)%3]]));	//glTexCoord2dv((double*)&(gFEM.mRest[gFEM.mTriangles[i][k]]));
		}
	glEnd();
	
	glFlush();
	glutSwapBuffers();
	int err = glGetError();
	if (err>0)
		std::cout<<"Drawing Error:"<<err<<std::endl;
}

void Keyboard(unsigned char iKey, int x, int y)
{

}

void main(int argc, char** argv)
{

	OGLFrame::Init(640,480);
	//OGLFrame::GetInstance()->SetCommonFunction();
	OGLFrame::GetInstance()->AddRenderExt(TestRender);
	OGLFrame::EnableIdleRender();
	//OGLFrame::GetInstance()->AddKey0board(
	g_testCam = new OGLCamModel();
	g_testCam->EnableCam(OGLFrame::GetInstance());

	gFEM.InitRect(6, 6, 0.2);
	gFEM.InitParam(1e16, 0.4f);
	//for (int i=0; i<(int)gFEM.mForce.size(); i++)
	//	gFEM.mForce[i] = Vec2Float(0, -9.8f);
	gFEM.mForce[0] = Vec2Float(0, -10.0f);
	//gFEM.mForce[30] = Vec2Float(0, -10.0f);
	//gFEM.mForce[5] = Vec2Float(-10.0f, 0);
	//gFEM.mForce[33] = Vec2Float(0, 10.0f);
	//gFEM.mForce[32] = Vec2Float(0, 9.8f);
	//gFEM.mForce[35] = Vec2Float(0, -9.8f);
	//gFEM.mFixedVtx[30] = 1;
	//gFEM.mFixedVtx[31] = 1;
	//gFEM.mFixedVtx[32] = 1;
	//gFEM.mFixedVtx[33] = 1;
	//gFEM.mFixedVtx[34] = 1;
	gFEM.mFixedVtx[35] = 1;
	gFEM.Compute();
	cout<<"Length\t"<<gFEM.mRest[gFEM.mRest.size()-1]-gFEM.mRest[0]<<endl;
	//glewInit();
	//g_pProgram = new OGLSEasyProgram(NULL,"restshader.txt");
	//g_pProgram->Use();
	glutMainLoop();
}
