/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "..\StaticFEM\Static2D.h"
#include "..\StaticFEM\StaticTable.h"

#include <gl\glew.h>
#include "..\SSSLib\SSSLibOGL\OGLFrame.h"
#include "..\SSSLib\SSSLibOGL\OGLCamModel.h"
#include "..\SSSLib\SSSLibOGL\OGLSimpleObj.h"
#include "..\SSSLib\SSSLibOGL\OGLTexture.h"
#include "..\SSSLib\SSSLibOGL\OGLSEasyProgram.h"
#include "..\SSSLib\SSSSmallVec.h"
#include <iostream>
//#include "..\FEMLib\FEMObj.h"
#include "..\SSSLib\SSSColor.h"
#include <Windows.h>
#include <GL\freeglut.h>

using namespace SSSLib;
using namespace std;

//#define _CREATE_TABLE_SET
//#define _OUTPUT_ALL_TABLES

OGLCamModel* g_testCam;
OGLSEasyProgram* g_pProgram;
StaticTable gFEM;

void TestRender(OGLScene::TStageName, int)
{

	g_testCam->SetProjMatrix();
	g_testCam->SetViewMatrix();
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glColor3f(0, 0, 1.0f);

	/*glBegin(GL_LINES);
		for (int i=0; i<(int)gFEM.mTriangles.size(); i++)
		for (int j=0; j<3; j++)
		{
			glVertex2dv((double*)&(gFEM.mStatic[gFEM.mTriangles[i][j]]));	//glTexCoord2dv((double*)&(gFEM.mRest[gFEM.mTriangles[i][j]]));
			glVertex2dv((double*)&(gFEM.mStatic[gFEM.mTriangles[i][(j+1)%3]]));	//glTexCoord2dv((double*)&(gFEM.mRest[gFEM.mTriangles[i][k]]));
		}
	glEnd();*/
	glBegin(GL_TRIANGLES);
		for (int i=0; i<(int)gFEM.mTriangles.size(); i++)
		{
			//glColor3fv(Value2HSVf(float(gFEM.mNormalizedPS[i]*0.5)).val);
			for (int j=0; j<3; j++)
			{
				//glColor3fv(Value2HSVf(float(gFEM.mVtxNormalizedPS[gFEM.mTriangles[i][j]]*0.5)).val);
				//_T_FLOAT ps = gFEM.SamplePS(gFEM.mRest[gFEM.mTriangles[i][j]]/gFEM.mGridScale+gFEM.mOrigin)[0];

				_T_FLOAT ps = gFEM.SamplePS(gFEM.mRest[gFEM.mTriangles[i][j]])[0];
				ps = (ps-gFEM.mMinPS)/(gFEM.mMaxPS-gFEM.mMinPS);
				glColor3fv(Value2HSVf(float(ps*0.5)).val);
				glVertex2dv((double*)&(gFEM.mStatic[gFEM.mTriangles[i][j]]));
			}
		}
	glEnd();
	
	glFlush();
	glutSwapBuffers();
	int err = glGetError();
	if (err>0)
		std::cout<<"Drawing Error:"<<err<<std::endl;
}

void Keyboard(unsigned char iKey, int x, int y)
{

}

void main(int argc, char** argv)
{
	int reso = 5;
	OGLFrame::Init(640,480);
	//OGLFrame::GetInstance()->SetCommonFunction();
	OGLFrame::GetInstance()->AddRenderExt(TestRender);
	OGLFrame::EnableIdleRender();
	//OGLFrame::GetInstance()->AddKey0board(
	g_testCam = new OGLCamModel();
	g_testCam->EnableCam(OGLFrame::GetInstance());

	ofstream legStress("legStress.txt");
	ofstream jointStress("jointStress.txt");

	//gFEM.InitRect(6, 6, 0.2);
	gFEM.InitParam(1e6, -0.4f);


#ifndef _CREATE_TABLE_SET
	gFEM.SetParameters(8*reso, 1*reso, 5*reso, 4*reso, 1*reso, 0, 0, 0.2f/reso);
	gFEM.BuildTable();
	gFEM.Compute();
	gFEM.ComputeStrainStress();
#else
	for (int sw=6; sw<=10; sw++)
	for (int ld=2-sw%2; ld<=sw-2; ld+=2)
	for (int ll=1; ll<=9; ll+=2)
	for (int st=1; st<=2 && st+ll<=10; st++)
	for (int lw=1; lw<=2 && lw*2+ld<=sw; lw++)
	for (int bh=1; bh==1 || bh<=ll-2; bh++)
	for (int bt=0; bt==0 || (bt<=1 && bt+bh<=ll-1); bt++)
	{
		if (bt==0 && bh!=1)
			continue;
		gFEM.SetParameters(sw*reso, st*reso, ll*reso, ld*reso, lw*reso, bh*reso, bt*reso, 0.2f/reso);
		gFEM.BuildTable();
		//gFEM.InitParam(1e16, 0.0f);
		//gFEM.mForce[0] = Vec2Float(0, -0.1f);
		//gFEM.mFixedVtx[35] = 1;
		gFEM.Compute();
		gFEM.ComputeStrainStress();
		float sampleSize = 1.0f;

		char buffer0[10000];
		char buffer1[10000];
		if (bt!=0)
			sprintf(buffer0, "sw%dld%dll%dst%dlw%dbh%dbt%d", sw, ld, ll, st, lw, bh, bt);	
		else
			sprintf(buffer0, "sw%dld%dll%dst%dlw%d", sw, ld, ll, st, lw);
		cout<<buffer0<<endl;
		float bottom = -(ll+st)*0.5f*0.2f;
		vector<Vec2f> samples;
		vector<float> density;
#ifdef _OUTPUT_ALL_TABLES
		gFEM.SampleTable(-sampleSize, bottom, sampleSize, bottom+2*sampleSize, 512, 64, samples, density);
#endif

		// sample leg and joint stress
		{
			for (int i=0; i<2; i++)
			{
				ofstream* outFile;
				Vec2Float pst;
				if (i==0)
				{
					outFile = &legStress;
					pst[1] = bottom+1e-5;
					pst[0] = -(ld+lw)*0.5*0.2;
				}
				else
				{
					outFile = &jointStress;
					pst[0] = -ld*0.5*0.2-1e-5;
					pst[1] = bottom+ll*0.2+1e-5;
				}
				bool onMesh;
				Vec2Float ps = gFEM.SamplePS(pst, &onMesh);

				*outFile<<buffer0<<"\t"<<ps[0]<<"\t"<<ps[1]<<endl;
				assert(onMesh);
			}
		}

#ifdef _OUTPUT_ALL_TABLES
		sprintf(buffer1, "move /y test.png %s.png", buffer0);
		system(buffer1);
		sprintf(buffer1, "move /y testdensity.png %s_density.png", buffer0);
		system(buffer1);
		sprintf(buffer1, "%s.ps", buffer0);
		gFEM.SaveVec(buffer1, samples);
		sprintf(buffer1, "%s.density", buffer0);
		gFEM.SaveVec(buffer1, density);
#endif
	}
	exit(1);
#endif


	cout<<"Length\t"<<gFEM.mRest[gFEM.mRest.size()-1]-gFEM.mRest[0]<<endl;
	//glewInit();
	//g_pProgram = new OGLSEasyProgram(NULL,"restshader.txt");
	//g_pProgram->Use();
	glutMainLoop();
}
